#ifndef COMMONLISTITERATOR_H
#define COMMONLISTITERATOR_H
#include<RAMS/mseg.h>
#include<RAMS/elementartypes.h>
#include<RAMS/GrowingBuffer.h>
namespace RAMS
{
   class CommonListIterator
   {
   public:
     CommonListIterator(RAMS::Mseg& seg,off_t first):seg_(&seg),cur_(first) {}
     bool end() { return cur_==RAMS::RNIL; }
     void next()
	 {
	     cur_=*(off_t *)((octet_t *)(seg_->begin())+cur_);
	 }
     octet_t *content() { return (octet_t *)(seg_->begin())+cur_+sizeof(off_t); }
   protected:
     RAMS::Mseg *seg_;
    off_t cur_;
   };

   /* Chains forward - in bitorb there is the sequence important */
   class CommonListAllocator
   {
   public: 
      CommonListAllocator(GrowingBuffer& seg,off_t *root):seg_(&seg),root_(root)
      {
	  *root=RAMS::RNIL;
	  last_=root_;
      }
      CommonListAllocator():seg_(0),root_(0),last_(0) {}
      void set(GrowingBuffer& seg,off_t *root)
      {
	  seg_=&seg;
	  root_=root;
	  last_=root_;
      }

      octet_t *add(size_t s)
      {
	  off_t *cur=(off_t *)seg_->wr_ptr(*last_,2,sizeof(off_t));
	  *cur=RAMS::RNIL;
	  last_=cur;
	  return seg_->wr_ptr(s);
      }
   protected:
      GrowingBuffer *seg_; 
      off_t *root_;
      off_t *last_;
   }; 

 
};
#endif
