#ifndef CLASSGENERATOR_H
#define CLASSGENERATOR_H
#include<sys/types.h>
#include<string>

class ElementGenerator
{
public:
    virtual void addComment(const char *text,size_t len)=0;
    virtual void finish()=0;
};

class Scope
{
public:
    virtual std::string Name()=0;
    virtual ~Scope();
};

class PackageGenerator: public ElementGenerator, public Scope
{
};

class ClassGenerator : public ElementGenerator, public Scope
{
public:
    virtual void addSuperClass(const char *name)=0;
    virtual ElementGenerator *addProperty(const char *name,const char *id,
			     const char *typ,bool typeelem,
			     const char *def=0)=0;
    virtual ElementGenerator *addMultiProperty(const char *name,const char *id,
				  const char *typ,bool typeelem)=0;
    virtual ElementGenerator *addOptionalProperty(const char *name,
						  const char *id,
						  const char *typ,
						  bool typeelem)=0;
    
    virtual ~ClassGenerator() {}
};

class AbstractCodeFactory
{
public:
   virtual PackageGenerator *genPackage(Scope *scope,const char *name,const char *id,const char *uri)=0;
   virtual ClassGenerator *genClass(Scope *scope,const char *name,const char *id)=0;
};
#endif
