#include"GenIteration.h"
#include"NullElementGenerator.h"
#include"classname2names.h"
#include"output.h"
extern "C" void set_ramsomf_factory(AbstractCodeFactory *f);
extern "C" const char *get_semantik_name();

class Global
{
public:
  Global()
  {
     set_ramsomf_factory(&itfactory);
  };
private:
  Iteratorfactory itfactory;
};

static Global initobj;
static NullElementGenerator nullelementgenerator;


GenPackage::GenPackage(Scope *scope,const char *name,const char *id,const char *uri):name_(name)
{
}

void GenPackage::addComment(const char *text,size_t len)
{
}

void GenPackage::finish()
{
}

std::string GenPackage::Name()
{
    return name_;
}

Iteratorfactory::Iteratorfactory()
{
    // Vergl. GenSemantik::GenSemantik
    semantikclassname_ = std::string(get_semantik_name()) + "_IteratorSemantik";
    Classname2names cn(semantikclassname_.c_str());
    cbsemantikclassname_ = std::string(get_semantik_name()) + "_CBSemantik";
    Classname2names cbcn(cbsemantikclassname_.c_str());

    header_.open(cn.headerfilename());
    header_ << "#ifndef " << cn.includestopper() << "\n"
	    << "#define " << cn.includestopper() << std::endl;
    header_ << "#include\"" << get_semantik_name() << "_Semantik.h\"" << std::endl;   
    header_ << "#include\"" << cbcn.headerfilename() << "\"" << std::endl;
    header_ << std::endl;
    header_ << "class " << semantikclassname_
	    << " : public " << get_semantik_name() << "_Semantik\n"
	    << "{\n" << "public:\n";
    header_ << indent(1) << semantikclassname_
	    << "::" << semantikclassname_
	    << "(" << cbsemantikclassname_ << " *cbsem,bool visitinh=false):cbsem_(cbsem),visitinh_(visitinh) {}"
	    << std::endl;
    body_.open(cn.bodyfilename());
    body_ << "#include\"" << cn.headerfilename() << "\"\n"
	  << "#include\"alltypes.h\"\n" << std::endl;

    cbheader_.open(cbcn.headerfilename());
    cbheader_ << "#ifndef " << cbcn.includestopper() << "\n"
	      << "#define " << cbcn.includestopper() << std::endl;

    cbheader_ << std::endl;
   
    cbbody_.open(cbcn.bodyfilename());
    cbbody_ << "#include<iostream>" << std::endl;
    cbbody_ << "#include\"" << cbcn.headerfilename() << "\"\n"
	    << "#include\"alltypes.h\"\n" << std::endl;
    
}

Iteratorfactory::~Iteratorfactory()
{
    header_ << "private:\n"
	    << indent(1) << cbsemantikclassname_ << " *cbsem_;\n"
	    << indent(1) << "bool visitinh_;\n"
	    << std::endl;
    header_ << "};\n" << std::endl;
    header_ << "#endif" << std::endl;
    cbheader_ << predeclcollector_.str() << std::endl;
    cbheader_ << "class " << cbsemantikclassname_ << "\n{\n"
	      << "public:" << std::endl;
    cbheader_ << cboperations_.str();
    cbheader_ << "};\n"
	      << "#endif" << std::endl;
}


PackageGenerator *Iteratorfactory::genPackage(Scope *scope,const char *name,const char *id,const char *uri)
{
    return new GenPackage(scope,name,id,uri);
}

ClassGenerator *
Iteratorfactory::genClass(Scope *scope,const char *name,const char *id)
{
    const char *namesp = (scope ? scope->Name().c_str() : 0);
    predeclcollector_.addClass(namesp,name);
    header_ << indent(1) << "virtual void v" << name << "(";
    body_ << "void " << semantikclassname_ << "::v" << name << "(";
    if(namesp)
    {
	header_ << namesp << "::";
	body_ << namesp << "::";
    }
    header_ << name << "*);" << std::endl;
    body_ << name << "* a" << name << ")" << std::endl;
    
    opencbopbody(namesp,name,"begin");
    cbbody_ << indent(1) << "std::cout << \"" << namesp << "::" << name << "\\n{\" << std::endl;\n";
    cbbody_ << "}\n" << std::endl; 
    opencbopbody(namesp,name,"end");
    cbbody_ << indent(1) << "std::cout << \"} //" << namesp << "::" << name << "\" << std::endl;\n";
    cbbody_ << "}\n" << std::endl; 
    
    return new GenIteration(body_,namesp,name);
}

void Iteratorfactory::opencbopbody(const char *namesp,const char *name,const char *be)
{
    cboperations_ << indent(1) << "virtual void cb_" << name << "_" << be << "(";
    cbbody_ << "void " << cbsemantikclassname_ << "::cb_" << name << "_" << be << "(";
    if(namesp)
    {
	cboperations_ << namesp << "::";
	cbbody_ << namesp << "::";
    }
    cboperations_ << name << "* a" << name << ");" << std::endl;
    cbbody_ << name << "* a" << name << ")\n{\n" << std::endl;
}

GenIteration::GenIteration(std::ostream& str,const char *namesp,const char *cname):body_(str),cnamesp_(namesp ? namesp : ""),cname_(cname),finished_(false),indentlevel_(0)
{
    paraname_ = "a"+cname_;
    body_ << "{" << std::endl;
    body_ << indent(1) << "cbsem_->cb_" << cname_ << "_begin("
	  << paraname_ << ");" << std::endl;
}

void GenIteration::finish()
{
    body_ << indent(1) << "cbsem_->cb_" << cname_ << "_end("
	  << paraname_ << ");" << std::endl;
    body_ << "}\n" << std::endl;
}

GenIteration::~GenIteration()
{
    if(!finished_)
    {
	finish();
    }
}

std::string GenIteration::Name()
{
    return cname_;
}

void GenIteration::addComment(const char *text,size_t len)
{
}


void GenIteration::addSuperClass(const char *name)
{
    body_ << indent(1) << "if(visitinh_) { " 
	  << "v" << name << "(" << paraname_ << "); } // visit Superclass" 
	  << std::endl;
}

ElementGenerator *
GenIteration::addProperty(const char *name,const char *id,
			     const char *typ,bool typeelem,
			     const char *def)
{
    if(!typeelem)
    {
	body_ << indent(indentlevel_+1) << typ << " *" << name << " = " 
	      << paraname_ << " ->"  << name << "();" << std::endl;
	body_ << indent(indentlevel_+1) << name << "->_callVisitor(this);"
	      << std::endl;
    }
    else
    {
	body_ << indent(indentlevel_+1)
	      <<  "//sem->v" << typ << "(" << paraname_ << "->"
	      << name << "());" << std::endl; 
    }
    return &nullelementgenerator;
}

ElementGenerator *
GenIteration::addOptionalProperty(const char *name,
						  const char *id,
						  const char *typ,
						  bool typeelem)
{
    ElementGenerator *ret=0;
    indentlevel_++;
    body_ << indent(indentlevel_) << "if(" << paraname_ << "->is_" << name
	  << "_valid())\n"
	  << indent(indentlevel_) << "{\n";
    ret=addProperty(name,id,typ,typeelem);
    body_ << indent(indentlevel_) << "}\n";
    indentlevel_--;
    return ret;
}

ElementGenerator *
GenIteration::addMultiProperty(const char *name,const char *id,
				  const char *typ,bool typeelem)
{
    std::string itname = std::string(name) + std::string("_it");
    body_ << indent(1) << (cnamesp_.length() > 0 ? cnamesp_ + "::" : "")
	  << cname_ << "::" << name << "_iterator " << itname 
	  << " = " << paraname_ << "->get_" << name << "_iterator();"
	  << std::endl;
    body_ << indent(1) << "while(!" << itname << ".end())\n"
	  << indent(1) << "{\n"
	  << indent(2) << itname << "()->_callVisitor(this);\n"
	  << indent(2) << itname << ".next();\n"
	  << indent(1) << "}" << std::endl;
    body_ << std::endl;
    return &nullelementgenerator; 
}


