#ifndef GENITERATION_H
#define GENITERATION_H
#include"ClassGenerator.h"
#include<fstream>
#include<sstream>
#include"PreDeclCollector.h"

class GenIteration : public ClassGenerator
{
public:
   GenIteration(std::ostream& str,const char *cnamsp,const char *cname);
   ~GenIteration();
    virtual void addComment(const char *text,size_t len);
    virtual void finish();
    virtual std::string Name();
    virtual void addSuperClass(const char *name);
    virtual ElementGenerator *addProperty(const char *name,const char *id,
			     const char *typ,bool typeelem,
			     const char *def=0);
    virtual ElementGenerator *addMultiProperty(const char *name,const char *id,
				  const char *typ,bool typeelem);
    virtual ElementGenerator *addOptionalProperty(const char *name,
						  const char *id,
						  const char *typ,
						  bool typeelem);
private:
    std::ostream& body_;
    std::string cnamesp_;
    std::string cname_;
    std::string paraname_;
    bool finished_;
    int indentlevel_;
};

class GenPackage : public PackageGenerator
{
public:
    GenPackage(Scope *scope,const char *name,const char *id,const char *uri);
    void addComment(const char *text,size_t len);
    virtual void finish();
    std::string Name();
private:
    std::string name_;
};

class Iteratorfactory : public AbstractCodeFactory
{
public:
    Iteratorfactory();
    ~Iteratorfactory();
    virtual PackageGenerator *genPackage(Scope *scope,const char *name,const char *id,const char *uri);
    virtual ClassGenerator *genClass(Scope *scope,const char *name,const char *id);
private:
   PreDeclCollector predeclcollector_;
   // writes declaration of the CBsemantics head and opens body 
   void opencbopbody(const char *namesp,const char *name,const char *be);
   std::string semantikclassname_;
   std::string cbsemantikclassname_;
   std::ofstream header_;
   std::ofstream body_;
   std::ofstream cbheader_;
   std::ofstream cbbody_;
   std::ostringstream cboperations_;
};
#endif
