#include"GenSemantik.h"
#include"classname2names.h"
#include"output.h"

GenSemantik::GenSemantik(const char *title):nocode_(true)
{
    if(title)
    {
	nocode_=false;
	semantikclassname_ = std::string(title) + "_Semantik";
	Classname2names cn(semantikclassname_.c_str());
	header_.open(cn.headerfilename());
	header_ << "#ifndef " << cn.includestopper() << "\n"
		<< "#define " << cn.includestopper() << std::endl;
	header_ << "#include<ramsmof/Visitor.h>" << std::endl;
    }
}

void GenSemantik::addClass(const char *namesp,const char *name)
{
    if(nocode_) return;
    predeclcollector_.addClass(namesp,name);
    operations_ << indent(1) << "virtual void v" << name << "(";
    if(namesp)
    {
	operations_ << namesp << "::";
    }
    operations_ << name << "*) = 0;" << std::endl;
}

GenSemantik::~GenSemantik()
{
    if(nocode_) return;
    header_ << predeclcollector_.str();
    header_ << std::endl;
    header_ << "class " << semantikclassname_
	    << " : public ::RAMS::MOF::Visitor\n"
	    << "{\n" << "public:\n";
    header_ << operations_.str() << std::endl;
    header_ << "};\n" << std::endl;
    header_ << "#endif" << std::endl;
}

