#ifndef CLASSWRITER_H
#define CLASSWRITER_H
#include<string>
#include<fstream>
#include<sstream>
#include"ClassGenerator.h"

class ClassWriter;
class CommonContentElement : public ElementGenerator
{
public:
    CommonContentElement(ClassWriter *cw):finished_(true),cw_(cw) {}
    virtual void addComment(const char *text,size_t len);
    virtual void finish();
    std::ostringstream &decl() { finished_=false; return decl_; }
    void checkfinished();
private:
    int finished_;
    ClassWriter *cw_;
    std::ostringstream comment_;
    std::ostringstream decl_;
};

class Package : public PackageGenerator
{
public:
    Package(Scope *scope,const char *name,const char *id,const char *uri);
    std::string Name();
    void addComment(const char *text,size_t len);
    virtual void finish();
private:
    std::string name_;
    Scope *scope_;
};

class ClassWriter : public  ClassGenerator
{
public:
    ClassWriter(Scope *scope,const char *name,const char *id);
    void addSuperClass(const char *name);
    std::string Name();
    ElementGenerator *addProperty(const char *name,const char *id,const char *typ,bool type_is_elementar,const char *def=0);
    ElementGenerator *addMultiProperty(const char *name,const char *id,
			  const char *typ,bool type_is_elementar);
    ElementGenerator *addOptionalProperty(const char *name,const char *id,
			     const char *typ,bool type_is_elementar);
    void addComment(const char *text,size_t len);
    void finish();
    ~ClassWriter();
    std::ostringstream &decl() { return classpublic_; }
    int level() { return level_; }
private:
    bool finished_;
    const char *namespace_;
    std::string name_;
    int level_;
    int numbersuperclasses_;
    bool iteratorheaderincl_;
    std::ofstream header_;
    std::ofstream body_;
    std::ostringstream includes_;
    std::ostringstream comment_;
    std::ostringstream classhead_;
    std::ostringstream layouthead_;
    std::ostringstream classpublic_;
    std::ostringstream layout_;
    std::ostringstream classprivate_;
    std::ostringstream constructordecl_;
    std::ostringstream constructorbody_;
    std::ostringstream destructorbody_;
    std::ostringstream setsegbody_;
    std::ostringstream initfunc_;
    CommonContentElement contentele_;
};

class CPPCodeFactory : public AbstractCodeFactory
{
public:
    PackageGenerator *genPackage(Scope *scope,const char *name,const char *id,const char *uri);
    ClassGenerator *genClass(Scope *scope,const char *name,const char *id);
};
#endif
