#include"genresolver.h"
#include"output.h"
#include"classname2names.h"
#include"typename2id.h"

GenResolver::GenResolver()
{
    allheaders_.open("alltypes.h",std::ios_base::out);
    body_.open("resolver.cc",std::ios_base::out);
    body_ << "#include<ramsmof/Resolver.h>" << std::endl;
    body_ << "#include\"alltypes.h\"" << std::endl;
    body_ << "RAMS::MOF::Object *resolve(RAMS::MOF::typeid_t tid)\n{\n";
    body_ << indent(1) << "switch(tid)\n" << indent(1) << "{\n";
}

void GenResolver::addClass(const char *namesp,const char *tname)
{
    Typename2Id typename2id;
    Classname2names cnn(tname);
    body_ << indent(1) << "case 0x" << std::hex << typename2id(tname) << ":\t"
	  << "return new ";
    if(namesp)
    {
	body_ << namesp << "::";
    } 
    body_ << tname << "();\n";
    allheaders_ << "#include\"" << cnn.headerfilename() << "\"\n";
}

GenResolver::~GenResolver()
{
    body_ << indent(1) << "default:\n";
    body_ << indent(2) << "throw ResolverError(tid);" << std::endl;  
    body_ << indent(2) << "return 0;" << std::endl;
    body_ << indent(1) << "}\n";
    body_ << "}\n";
}

