#include<iostream>
#include"ClassGenerator.h"
#include<dlfcn.h>

AbstractCodeFactory *the_factory;
extern "C" void set_ramsomf_factory(AbstractCodeFactory *f)
{
  the_factory=f;
}

extern "C" const char *get_semantik_name()
{
  return "Test";
}

int main(int argc,char **argv)
{
    const char *lib="codewriter.so";
    if(argc>1)
    {
	lib=argv[1];
    }
    std::cerr << "Loading " << lib << " ... " << std::endl;
    void *dlh = dlopen(lib,RTLD_NOW);	
    if(dlh==0)
    {
	std::cerr << "Loading " << lib << ":" << dlerror() << std::endl;
        exit(1);
    }
    ElementGenerator *eg;
    PackageGenerator *pack = the_factory->genPackage(0,"L0","l0_1",0);
    ClassGenerator *cw=the_factory->genClass(pack,"Tc","0");
    const char *comment = "a example for a generated class";
    cw->addComment(comment,strlen(comment));
    cw->addSuperClass("diedel");
    cw->addSuperClass("fiedel");
    eg=cw->addProperty("prop","id_prop","Boolean",true,"false");
    comment = "a simple property";
    eg->addComment(comment,strlen(comment));
    eg->finish();

    eg=cw->addOptionalProperty("opt","id_opt","int",true);
    comment = "a  optional property";
    eg->addComment(comment,strlen(comment));
    eg->finish();

    eg=cw->addMultiProperty("multi","id_multi","T",false);
    comment = "a multiple property";
    eg->addComment(comment,strlen(comment));
    eg->finish();
    
    cw->finish();
    delete cw;
    pack->finish();
    delete pack;
    dlclose(dlh);
};
