#include"xmiwriter.h"

void CommonElement::addComment(const char *text,size_t len)
{
}

void CommonElement::finish()
{
}

XMIWriter::XMIWriter(Scope *scope,const char *name,const char *id):finished_(false),name_(name)
{
    std::string classname(name);
    std::string filename = classname + std::string(".xmi");
    out_.open(filename.c_str(),std::ios_base::out);
    out_ << "<cmof:Class xmi:id=\"" << id << "\" name=\"" << name << "\">"
	 << std::endl;
}

std::string XMIWriter::Name()
{
    return name_;
}

void XMIWriter::addSuperClass(const char *name)
{
}

ElementGenerator *XMIWriter::addProperty(const char *name,const char *id,
			    const char *typ,bool telem,const char *def)
{
    out_ << "<ownedAttribute xmi:type=\"cmof:Property\" xmi:id=\"" << id << "\""
	 << " name=\""<< name << "\" type=\"" << typ << "\" ";
    if(def)
    {
	out_ << "default=\"" << def << "\"";
    }
    out_ << "/>" << std::endl;

    return &commonele_;
}

ElementGenerator *XMIWriter::addMultiProperty(const char *name,const char *id,
				 const char *typ,bool telem)
{
    out_ << "<ownedAttribute xmi:type=\"cmof:Property\" xmi:id=\"" << id << "\""
	 << " name=\""<< name << "\" type=\"" << typ << "\" "
	 << "lower=\"0\" upper=\"*\"/>" << std::endl;
    return &commonele_;
}
ElementGenerator *XMIWriter::addOptionalProperty(const char *name,const char *id,
				    const char *typ,bool telem)
{
    out_ << "<ownedAttribute xmi:type=\"cmof:Property\" xmi:id=\"" << id << "\""
	 << " name=\""<< name << "\" type=\"" << typ << "\" "
	 << "lower=\"0\" upper=\"1\"/>" << std::endl;
    return &commonele_;
}

void XMIWriter::addComment(const char *text,size_t len)
{
    out_ << "   <ownedComment><body>";
    for(const char *c=text;c<text+len;c++)
    {
	out_ << *c;
    }
    out_ << "<body></ownedComment>" << std::endl;
}

void XMIWriter::finish()
{
    out_ << "</cmof:Class>" << std::endl;
    out_.close();
}

XMIWriter::~XMIWriter()
{
    if(!finished_)
    {
	finish();
    }
}
