#ifndef XMIWRITER_H
#define XMIWRITER_H
#include<string>
#include<fstream>
#include<sstream>
#include"ClassGenerator.h"

class CommonElement : public ElementGenerator
{
public:
    void addComment(const char *text,size_t len);
    void finish();
};

class XMIPackageWriter : public PackageGenerator
{
public:
    XMIPackageWriter(Scope *scope,const char *name,const char *id,const char *uri);
    std::string Name();
    void addComment(const char *text,size_t len);
    void finish();
private:
    std::string name_;
};

class XMIWriter : public  ClassGenerator
{
public:
    XMIWriter(Scope *scope,const char *name,const char *id);
    std::string Name();
    void addSuperClass(const char *name);
    ElementGenerator *addProperty(const char *name,const char *id,
		     const char *typ,bool telem,const char *def=0);
    ElementGenerator *addMultiProperty(const char *name,const char *id,
			  const char *typ,bool telem);
    ElementGenerator *addOptionalProperty(const char *name,const char *id,
			     const char *typ,bool telem);
    void addComment(const char *text,size_t len);
    void finish();
    ~XMIWriter();
private:
    bool finished_;
    std::string name_;
    int level_;
    std::ofstream out_;
    CommonElement commonele_;
};

class XMIFactory : public AbstractCodeFactory
{
 public:
    PackageGenerator *genPackage(Scope *scope,const char *name,const char *id,const char *uri);
    ClassGenerator *genClass(Scope *scope,const char *name,const char *id);
};
#endif
