#include"L0ModelWriter.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/mman.h>
#include<fcntl.h>
#include<string.h>
#include"L0Layout.h"
#include<stdlib.h>
#include<iostream>

L0ModelWriter::L0ModelWriter(int pages):root_(0)
{
    int fd=::open("/dev/zero",O_RDONLY);
    size_t size = (size_t)pages << 12;
    seg_.init((char *)::mmap(0,size,PROT_READ|PROT_WRITE,MAP_PRIVATE,fd,0),size);    
    layout_=(L0Layout *)seg_.wr_ptr(sizeof(L0Layout));
    memcpy(layout_->head,"L0",3);
    layout_->roottid=0;
}

void  L0ModelWriter::root(::RAMS::MOF::Object *first)
{
    layout_->roottid=first->_typeid();
    first->_setsegandrep(&seg_,seg_.wr_ptr(first->_layout_size()));
    first->_init();
    root_=first;
}

void L0ModelWriter::open(const char *modelname)
{
    strcpy(filename_,modelname);
    strcat(filename_,".per");
}

void L0ModelWriter::save()
{
    int fd=::open(filename_,O_CREAT|O_TRUNC|O_WRONLY,0644);
    if(fd<-1)
    {
	std::cerr << "Can't write " << filename_ << std::endl; exit(1);
    }  
    int nw=::write(fd,seg_.begin(),seg_.length());
    if(nw<seg_.length())
    {
	std::cerr << "nur " << nw << " geschrieben ???? " << std::endl;
    }
    ::close(fd);
}
