#ifndef L0FILLER_H
#define L0FILLER_H
#include"ClassGenerator.h"
#include"L0ModelWriter.h"
#include"alltypes.h"

class L0ClassFiller : public ClassGenerator
{
public:
    L0ClassFiller(Scope *scope,const char *name,const char *id);
    virtual void addComment(const char *text,size_t len);
    virtual void finish();
    virtual std::string Name();
    virtual void addSuperClass(const char *name);
    virtual ElementGenerator *addProperty(const char *name,const char *id,
			     const char *typ,bool typeelem,
			     const char *def=0);
    virtual ElementGenerator *addMultiProperty(const char *name,const char *id,
				  const char *typ,bool typeelem);
    virtual ElementGenerator *addOptionalProperty(const char *name,
						  const char *id,
						  const char *typ,
						  bool typeelem);
    
    virtual ~L0ClassFiller();
private:
    L0::Class   class_;
    std::string name_;
};

class L0PackageFiller : public PackageGenerator
{
public:
    L0PackageFiller(Scope *scope,const char *name,const char *id,const char *uri);
    std::string Name();
    void addComment(const char *text,size_t len);
    void finish();
    L0::Package *package() { return &package_; }
private:
    L0::Package package_;
    std::string name_;
};


class L0FillerFactory : public AbstractCodeFactory
{
public:
    L0FillerFactory();
    ~L0FillerFactory();
    virtual PackageGenerator *genPackage(Scope *scope,const char *name,const char *id,const char *uri);
    virtual ClassGenerator *genClass(Scope *scope,const char *name,const char *id);
private:
  
};
#endif
