#include<errorhandling/errorhandling.h>
#include<iostream>
#include<ramsmof/StringOut.h>
#include<ramsmof/Resolver.h>
#include"alltypes.h"
#include"L0Layout.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<sys/mman.h>
#include<fcntl.h>
#include<string.h>
#include<errno.h>
#include"L0_CBPrintSemantik.h"
#include"L0_IteratorSemantik.h"

class L0Model
{
public:
    L0Model() {}
    ::RAMS::MOF::Object *open(const char *filename);
private:
    RAMS::GrowingBuffer seg_;
    const char *filename_;
};

::RAMS::MOF::Object *L0Model::open(const char *filename)
{
    struct stat fileinfo;
    int r;
    void *buf;
    ::RAMS::MOF::Object *ret=0;
    filename_=filename;
    int fd = ::open(filename,O_RDONLY);
    if(fd<0) throw Systemerror(errno,"open","Can't open file %s: %m",filename);
    r=fstat(fd,&fileinfo);
    if(r<0)  throw Systemerror(errno,"fstat","Can't fstat file %s: %m",filename);
    buf=::mmap(0,fileinfo.st_size,PROT_READ,MAP_PRIVATE,fd,0);
    if(buf==MAP_FAILED) throw Systemerror(errno,"mmap","mmap failed: %m");
    seg_.init((char *)buf,fileinfo.st_size,fileinfo.st_size);
    L0Layout *layout = (L0Layout *)seg_.begin();
    if(memcmp(layout->head,"L0",3)!=0) throw Error("%s is not a L0-Model",filename);
    ret=resolve(layout->roottid);
    if(ret)
    {
	ret->_setsegandrep(&seg_,layout->mem);
    }
    return ret;
}

L0Model model;
int main(int argc,char **argv)
{
    //RACE_LOGMSGBACKEND::instance()->init(argc,argv);
    if(argc<2)
    {
	std::cerr << "Usage: "  << argv[0] << " file.per" << std::endl;
	exit(1);
    }
    try
    {
	::RAMS::MOF::Object *rootobj = model.open(argv[1]);
#if 0 // ohne semantik
	L0::Package *package = dynamic_cast<L0::Package *>(rootobj);
	if(package)
	{
	    std::cout << package->name() << std::endl;
	}
	else
	{
	    std::cout << "Not a package ?" << std::endl;
	}
#endif
	//TestL0Semantik the_semantik;
	L0_CBPrintSemantik cbsem;
	L0_IteratorSemantik itsem(&cbsem);
	rootobj->_callVisitor(&itsem);
    }
    catch(std::exception& ex)
    {
	std::cerr << "Fatal: " << ex.what() << std::endl;
    }
}
