#ifndef XMIPARSERCONTEXT_H
#define XMIPARSERCONTEXT_H
#include"xmisax.h"
#include<string>
#include"ClassGenerator.h"

namespace XMIParser
{
    class ParserContext
    {
    public:
	ParserContext(XMIparser *parser):parser_(parser),level_(1),prev_(0) {}
	virtual std::string get_Name();
	virtual Scope *get_Scope();
	virtual void startelement(const xmlChar *name,const xmlChar **atts)=0;
	virtual void endelement(const xmlChar *name)=0;
	virtual void characters(const xmlChar *value,int len);
	virtual void addComment(const xmlChar *value,int len);
	virtual ~ParserContext();
    protected:
	void inclevel() { level_++; }
	void declevel(); // 
	XMIparser *parser_;
	int level_;
    public:
	ParserContext *prev_;
    };
};
#endif
