#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"XMIParser_AttributInterpreter.h"
#include"XMIParserContext_Operation.h"
#include"XMIParserContext_Comment.h"
#include"XMIParserContext_Rule.h"
#include"coutput.h"

using namespace XMIParser;

ParserContext_Operation::ParserContext_Operation(XMIparser *parser,const char *name,const char *xmiid):ParserContext(parser)
{
    Cindent cindent(*parser);
    std::cout << cindent << "/* id=" << xmiid << " */" << std::endl;
    std::cout << cindent << name << "()" << std::endl;
}

ParserContext_Operation::~ParserContext_Operation()
{
}

void ParserContext_Operation::startelement(const xmlChar *name,const xmlChar **atts)
{
    inclevel();
    if(xmlStrcmp(name, (const xmlChar *) "ownedComment")==0)
    {
	ParserContext_Comment *comment=new ParserContext_Comment(parser_,atts);
	level_--;
	parser_->push(comment);
    }
    else if(xmlStrcmp(name, (const xmlChar *) "ownedParameter")==0)
    {
	if(atts)
	{
	    AttributInterpreter ai;
	    ai.parse(atts);
	    std::cout << "Parameter: " << ai.typ() << " "
		      << (ai.name() ? ai.name() : "") << std::endl;
	}
	else
	{
	    std::cerr << "ownedParameter without Attribut " << std::endl;
	}
    }
    else if(xmlStrcmp(name, (const xmlChar *) "ownedRule")==0)
    {
	ParserContext_Rule *rule = new ParserContext_Rule(parser_);
	level_--;
	parser_->push(rule);
    }
    else
    {
	std::cerr << "(" << level_ << ") Unhandeled Element " << name << std::endl;
    }
}

void ParserContext_Operation::endelement(const xmlChar *name)
{
    std::cerr << "(" << level_ << ") Operation: endelement " << name << std::endl;
    declevel();
}

