#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"coutput.h"
#include"XMIParser_AttributInterpreter.h"
#include"XMIParserContext_Package.h"
#include"XMIParserContext_Class.h"
#include"XMIParserContext_Comment.h"
using namespace XMIParser;

ParserContext_Package::ParserContext_Package(XMIparser *parser,const xmlChar **atts):ParserContext(parser),package_(0)
{
    Scope *upperscope=0;
    const char *namesp=0;
    Cindent cindent(*parser);
    AttributInterpreter ai;
    ai.parse(atts);
    AttributTab *attrtab = ai.getTab();

    if(parser->get_deepth()> 2)
    {
	namesp=parser->top()->get_Name().c_str();
	upperscope = parser->top()->get_Scope();
    }
    std::cout << cindent << "/* id=" << ai.xmiid();
    AttributTab::const_iterator uriit = attrtab->find(std::string("uri"));
    if(uriit != attrtab->end())
    {
	std::cout <<  " uri=" << uriit->second << " */" << std::endl;
    }
    
    package_=the_factory->genPackage(upperscope,(ai.name() ? ai.name() : "unknown"),ai.xmiid(),(uriit != attrtab->end() ?  uriit->second.c_str() : (const char *)0));
    name_ = std::string(ai.name());
}

std::string ParserContext_Package::get_Name()
{
    return name_;
}

Scope *ParserContext_Package::get_Scope()
{
    return package_;
}

ParserContext_Package::~ParserContext_Package()
{
    delete package_;
}

void ParserContext_Package::startelement(const xmlChar *name,const xmlChar **atts)
{
    Cindent cindent(*parser_);
    std::cerr << "Package:startelement " << name << std::endl;
    inclevel();
    std::cerr << "(" << level_ << ")";
    if(xmlStrcmp(name, (const xmlChar *) "ownedComment")==0)
    {
	ParserContext_Comment *comment=new ParserContext_Comment(parser_,atts);
	level_--;
	parser_->push(comment);
    }
    else if(xmlStrcmp(name, (const xmlChar *) "ownedMember")==0)
    {
	AttributInterpreter ai;
	AttributTab *at;
	const xmlChar **a=atts;
	if(!atts)
	{
	    throw XMIError("ownedMember without Attributes");
	}
	ai.parse(atts);
	at=ai.getTab();

	std::cerr << "ownedMember " << ai.name()
		  << " of type " << ai.xmityp() << std::endl;
	if(ai.xmityp()==0) 
	{
	    std::cerr << "ERROR: cmof::type==0 " << std::endl;
	    return;
	}
	if(strcmp(ai.xmityp(),"cmof:Class")==0)
	{
	    ParserContext_Class *cmof_class = new ParserContext_Class(parser_,ai.name(),ai.xmiid(),*at);
	    level_--;
	    parser_->push(cmof_class);
	}
	else if(strcmp(ai.xmityp(),"cmof:PrimitiveType")==0)
	{
	    std::cout << cindent << "/* id= " << ai.xmiid() << "*/" << std::endl;
	    std::cout << cindent << "typedef " << ai.name() << ";" << std::endl;
	}
	else if(strcmp(ai.xmityp(),"cmof:Association")==0)
	{
	    std::cout << cindent << "/* id=" << ai.xmiid() << " Association "
		      << ai.name() << " */" << std::endl;
	}
	else
	{
	    std::cerr << "Package:Unhandeled Type " << ai.xmityp() << std::endl;
	}
	if(at) { delete at; }
    }
    else
    {
	std::cerr << "Unhandeled Element " << name << std::endl;
	if(atts!=0)
	{
	    for(const xmlChar **a=atts;*a!=0;a++)
	    {
		std::cerr << "\t" << *a << std::endl;
	    }
	}
    }
}

void ParserContext_Package::endelement(const xmlChar *name)
{
    std::cerr << "(" << level_ << ") Package: endelement " << name 
	      << std::endl;
    declevel();
}

