#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"XMIParserContext_XMI.h"
#include"XMIParserContext_Package.h"
#include"XMIParserContext_Class.h"
using namespace XMIParser;

void ParserContext_XMI::startelement(const xmlChar *name,const xmlChar **atts)
{
    inclevel();
    std::cerr << "XMI: startelement (" << level_ << ")" << name << std::endl;
    if(xmlStrcmp(name, (const xmlChar *) "cmof:Package")==0)
    {
	ParserContext_Package *package = new ParserContext_Package(parser_,atts);
	parser_->push(package);
	level_--;
    }
    else if(xmlStrcmp(name, (const xmlChar *) "cmof:Class")==0)
    {
	AttributInterpreter ai;
	AttributTab *at;
	if(!atts)
	{
	    throw XMIError("ownedMember without Attributes");
	}
	ai.parse(atts);
	at=ai.getTab();
	ParserContext_Class *cl = new ParserContext_Class(parser_,ai.name(),
							  ai.xmiid(),*at);
	parser_->push(cl);
	level_--;
    }
    else
    {
	
	std::cerr << "(" << level_ << ") Unhandeled Element " << name << std::endl;
    }
}

void ParserContext_XMI::endelement(const xmlChar *name)
{
    std::cerr << "(" << level_ << ") XMI: endelement" << name << std::endl;
    declevel();
}
