#include"XMIParser_AttributInterpreter.h"
#include<iostream>
using namespace XMIParser;

AttributInterpreter::AttributInterpreter()
    :xmityp_(0),xmiid_(""),name_(0),typ_(0),lower_(0),upper_(0),tab_(0)
{
    tab_ = new AttributTab();
}

AttributInterpreter::~AttributInterpreter()
{
    free(xmityp_);
    free(xmiid_);
    free(name_);
    free(typ_);
    free(lower_);
    free(upper_);
    if(tab_)
    {
	delete tab_;
    }
}
void AttributInterpreter::parse(const xmlChar **atts)
{
    if(atts == 0) return;
    const xmlChar **a=atts;
    while(*a!=0)
    {
	if(xmlStrcmp(*a,(const xmlChar *)"xmi:type")==0)
	{
	    xmityp_ =strdup((const char *)*(++a));
	}
	else if(xmlStrcmp(*a,(const xmlChar *)"xmi:id")==0)
	{
	    xmiid_ =strdup((const char *)*(++a));
	}
	else if(xmlStrcmp(*a,(const xmlChar *)"name")==0)
	{
	    name_ =strdup((const char *)*(++a));
	}
	else if(xmlStrcmp(*a,(const xmlChar *)"type")==0)
	{
	    typ_ =strdup((const char *)*(++a));
	}
	else if(xmlStrcmp(*a,(const xmlChar *)"lower")==0)
	{
	    lower_ =strdup((const char *)*(++a));
	}
	else if(xmlStrcmp(*a,(const xmlChar *)"upper")==0)
	{
	    upper_ =strdup((const char *)*(++a));
	}
	else
	{
	    const xmlChar *aname=*a;
	    const xmlChar *aval=*(++a);
	    std::string key((const char *)aname);
	    std::string value((const char *)aval);
	    (*tab_)[key]=value;
	    //std::cerr << aname << "=" << aval << std::endl;
	}
	a++;
    }
}

AttributTab *AttributInterpreter::getTab()
{
    AttributTab *ret=tab_;
    tab_=0;
    return ret;
}
