#ifndef XMI_PARSER_ATTRIBUTINTERPRETER_H
#define XMI_PARSER_ATTRIBUTINTERPRETER_H
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include<map>
#include<string>

namespace XMIParser
{
    typedef std::map<std::string,std::string> AttributTab;

    class AttributInterpreter
    {
    public:
	AttributInterpreter();
	~AttributInterpreter();
	void parse(const xmlChar **atts);
	const char *xmityp() { return xmityp_; }
	const char *xmiid() { return xmiid_; }
	const char *name() { return name_; }
	const char *typ() { return typ_; }
	const char *lower() { return lower_; }
	const char *upper() { return upper_; }
	AttributTab *getTab();
    private:
	char *xmityp_;
	char *xmiid_;
	char *name_;
	char *typ_;
	char *lower_;
	char *upper_;
	AttributTab *tab_;
    };
};
#endif
