#ifndef XMISAX_H
#define XMISAX_H
#include<libxml/parser.h>
#include<exception>
#include"ClassGenerator.h"

extern AbstractCodeFactory *the_factory;
namespace XMIParser
{
    class XMLError : public std::exception
    {
    public:
	virtual  const char *what() const throw();
    };

    class XMIError : public XMLError
    {
    public:
	XMIError(const char *msg, ...);
	virtual  const char *what() const throw();
    private:
	char msg_[256];
    };

    class ParserContext;
    class XMIparser
    {
    public:
	XMIparser();
	void parse(const char *filename);
	
	// internal
	ParserContext *top();
	void push(ParserContext *ctx);
	void pop();
	int get_deepth();
    private:
	static void startDocument(void *user_data);
	static void endDocument(void *userdata);
	static void warning(void *ctx,const char *msg, ...);
	static void error(void *ctx,const char *msg, ...);
	static void fatalerror(void *ctx,const char *msg, ...);
	static void startelement(void *ctx,const xmlChar *name,const xmlChar **atts);
	static void endelement(void *ctx,const xmlChar *name);
	static void attribute(void *ctx,const xmlChar *name,const xmlChar *value);
	static void characters(void *ctx,const xmlChar *value,int len);

	
	xmlSAXHandler handler;
	ParserContext *cur_context_;
	int deepth_;
    };

}; // namespace XMIParser
#endif
